/*******************************************************************************
 * This file is part of ODE Toolkit: a free application for solving systems of
 * ordinary differential equations.
 *  
 * Copyright (C) 2002-2011 Max Comstock, Beky Kotcon, Samantha Mesuro, Daniel Rozenfeld,
 * Anak Yodpinyanee, Andres Perez, Eric Doi, Richard Mehlinger, Steven Ehrlich,
 * Martin Hunt, George Tucker, Peter Scherpelz, Aaron Becker, Eric Harley,
 * Chris Moore
 * 
 * ODE Toolkit is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * 
 * ODE Toolkit is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * ODE Toolkit.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/

/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 1.0.1</a>, using an XML
 * Schema.
 * $Id$
 */

package io.castor;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Vector;

import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;

/**
 * Class VarListType.
 * 
 * @version $Revision$ $Date$
 */
public class VarListType implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field _varNamesList
     */
    private java.util.Vector _varNamesList;


      //----------------/
     //- Constructors -/
    //----------------/

    public VarListType() 
     {
        super();
        _varNamesList = new Vector();
    } //-- io.castor.VarListType()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addVarNames
     * 
     * 
     * 
     * @param vVarNames
     */
    public void addVarNames(java.lang.String vVarNames)
        throws java.lang.IndexOutOfBoundsException
    {
        _varNamesList.addElement(vVarNames);
    } //-- void addVarNames(java.lang.String) 

    /**
     * Method addVarNames
     * 
     * 
     * 
     * @param index
     * @param vVarNames
     */
    public void addVarNames(int index, java.lang.String vVarNames)
        throws java.lang.IndexOutOfBoundsException
    {
        _varNamesList.insertElementAt(vVarNames, index);
    } //-- void addVarNames(int, java.lang.String) 

    /**
     * Method enumerateVarNames
     * 
     * 
     * 
     * @return Enumeration
     */
    public java.util.Enumeration enumerateVarNames()
    {
        return _varNamesList.elements();
    } //-- java.util.Enumeration enumerateVarNames() 

    /**
     * Method getVarNames
     * 
     * 
     * 
     * @param index
     * @return String
     */
    public java.lang.String getVarNames(int index)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index >= _varNamesList.size())) {
            throw new IndexOutOfBoundsException("getVarNames: Index value '"+index+"' not in range [0.."+(_varNamesList.size() - 1) + "]");
        }
        
        return (String)_varNamesList.elementAt(index);
    } //-- java.lang.String getVarNames(int) 

    /**
     * Method getVarNames
     * 
     * 
     * 
     * @return String
     */
    public java.lang.String[] getVarNames()
    {
        int size = _varNamesList.size();
        java.lang.String[] mArray = new java.lang.String[size];
        for (int index = 0; index < size; index++) {
            mArray[index] = (String)_varNamesList.elementAt(index);
        }
        return mArray;
    } //-- java.lang.String[] getVarNames() 

    /**
     * Method getVarNamesCount
     * 
     * 
     * 
     * @return int
     */
    public int getVarNamesCount()
    {
        return _varNamesList.size();
    } //-- int getVarNamesCount() 

    /**
     * Method isValid
     * 
     * 
     * 
     * @return boolean
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * 
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * 
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Method removeAllVarNames
     * 
     */
    public void removeAllVarNames()
    {
        _varNamesList.removeAllElements();
    } //-- void removeAllVarNames() 

    /**
     * Method removeVarNames
     * 
     * 
     * 
     * @param index
     * @return String
     */
    public java.lang.String removeVarNames(int index)
    {
        java.lang.Object obj = _varNamesList.elementAt(index);
        _varNamesList.removeElementAt(index);
        return (String)obj;
    } //-- java.lang.String removeVarNames(int) 

    /**
     * Method setVarNames
     * 
     * 
     * 
     * @param index
     * @param vVarNames
     */
    public void setVarNames(int index, java.lang.String vVarNames)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index >= _varNamesList.size())) {
            throw new IndexOutOfBoundsException("setVarNames: Index value '"+index+"' not in range [0.." + (_varNamesList.size() - 1) + "]");
        }
        _varNamesList.setElementAt(vVarNames, index);
    } //-- void setVarNames(int, java.lang.String) 

    /**
     * Method setVarNames
     * 
     * 
     * 
     * @param varNamesArray
     */
    public void setVarNames(java.lang.String[] varNamesArray)
    {
        //-- copy array
        _varNamesList.removeAllElements();
        for (int i = 0; i < varNamesArray.length; i++) {
            _varNamesList.addElement(varNamesArray[i]);
        }
    } //-- void setVarNames(java.lang.String) 

    /**
     * Method unmarshal
     * 
     * 
     * 
     * @param reader
     * @return VarListType
     */
    public static io.castor.VarListType unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (io.castor.VarListType) Unmarshaller.unmarshal(io.castor.VarListType.class, reader);
    } //-- io.castor.VarListType unmarshal(java.io.Reader) 

    /**
     * Method validate
     * 
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
