/*******************************************************************************
 * This file is part of ODE Toolkit: a free application for solving systems of
 * ordinary differential equations.
 *  
 * Copyright (C) 2002-2011 Max Comstock, Beky Kotcon, Samantha Mesuro, Daniel Rozenfeld,
 * Anak Yodpinyanee, Andres Perez, Eric Doi, Richard Mehlinger, Steven Ehrlich,
 * Martin Hunt, George Tucker, Peter Scherpelz, Aaron Becker, Eric Harley,
 * Chris Moore
 * 
 * ODE Toolkit is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * 
 * ODE Toolkit is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * ODE Toolkit.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/

/* Generated By:JJTree&JavaCC: Do not edit this line. Parser.java */
package parser;

import java.util.Vector;

import parser.functions.Constant;
import parser.functions.UserDefinedFunction;
import parser.nodes.ASTBooleanOperatorNode;
import parser.nodes.ASTConstantDefinitionNode;
import parser.nodes.ASTFirstOrderODEDefinitionNode;
import parser.nodes.ASTFunctionDefinitionNode;
import parser.nodes.ASTFunctionNode;
import parser.nodes.ASTIdentifierNode;
import parser.nodes.ASTNumberNode;
import parser.nodes.ASTOperatorNode;
import parser.nodes.ASTPiecewiseNode;
import parser.nodes.ASTRelationalNode;

/*
 * not used:
 import java.util.Hashtable;
 import java.util.Stack;
 */
public class Parser/* @bgen(jjtree) */implements ParserTreeConstants,
ParserConstants {/* @bgen(jjtree) */
	protected JJTParserState jjtree = new JJTParserState();

	final public void Parse(ParserInterface p) throws ParseException,
	ParseException {
		label_1: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 23:
			case 24:
				;
				break;
			default:
				jj_la1[0] = jj_gen;
				break label_1;
			}
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 23:
				jj_consume_token(23);
				break;
			case 24:
				jj_consume_token(24);
				break;
			default:
				jj_la1[1] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
			}
		}
	label_2: while (true) {
		switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
		case ID:
			;
			break;
		default:
			jj_la1[2] = jj_gen;
			break label_2;
		}
		if (jj_2_1(2)) {
			functionDefinition(p);
		} else if (jj_2_2(2)) {
			firstOrderODEDefinition(p);
		} else {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case ID:
				constantDefinition(p);
				break;
			default:
				jj_la1[3] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
			}
		}
		label_3: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 23:
				jj_consume_token(23);
				break;
			case 24:
				jj_consume_token(24);
				break;
			default:
				jj_la1[4] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
			}
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 23:
			case 24:
				;
				break;
			default:
				jj_la1[5] = jj_gen;
				break label_3;
			}
		}
	}
	}

	final public void constantDefinition(ParserInterface p)
	throws ParseException, ParseException {
		/* @bgen(jjtree) ConstantDefinitionNode */
		ASTConstantDefinitionNode jjtn000 = new ASTConstantDefinitionNode(
				JJTCONSTANTDEFINITIONNODE);
		boolean jjtc000 = true;
		jjtree.openNodeScope(jjtn000);
		Token id;
		// never used: SimpleNode n;
		try {
			id = jj_consume_token(ID);
			jj_consume_token(25);
			additiveExpression(p);
			jjtree.closeNodeScope(jjtn000, true);
			jjtc000 = false;
			if (p.hasConstantNamed(id.image) || p.hasFunctionNamed(id.image) /*
			 * ||
			 * p
			 * .
			 * hasODEVarNamed
			 * (
			 * id
			 * .
			 * image
			 * )
			 * ||
			 * p
			 * .
			 * hasFunctionWithArgNamed
			 * (
			 * id
			 * .
			 * image
			 * )
			 */) {
				if (true)
					throw new ParseException("Duplicate identifier: "
							+ id.image);
			}
			p.addConstant(id.image, new Constant(jjtn000));
			jjtn000.dump("");
		} catch (Throwable jjte000) {
			if (jjtc000) {
				jjtree.clearNodeScope(jjtn000);
				jjtc000 = false;
			} else {
				jjtree.popNode();
			}
			if (jjte000 instanceof RuntimeException) {
				{
					if (true)
						throw (RuntimeException) jjte000;
				}
			}
			if (jjte000 instanceof ParseException) {
				{
					if (true)
						throw (ParseException) jjte000;
				}
			}
			{
				if (true)
					throw (Error) jjte000;
			}
		} finally {
			if (jjtc000) {
				jjtree.closeNodeScope(jjtn000, true);
			}
		}
	}

	@SuppressWarnings("unchecked")
	final public void functionDefinition(ParserInterface p)
	throws ParseException, ParseException {
		/* @bgen(jjtree) FunctionDefinitionNode */
		ASTFunctionDefinitionNode jjtn000 = new ASTFunctionDefinitionNode(
				JJTFUNCTIONDEFINITIONNODE);
		boolean jjtc000 = true;
		jjtree.openNodeScope(jjtn000);
		Token id;
		Vector args = new Vector();
		try {
			id = jj_consume_token(ID);
			jj_consume_token(26);
			definitionArgumentList(args, p);
			jj_consume_token(27);
			jj_consume_token(25);
			additiveExpression(p);
			jjtree.closeNodeScope(jjtn000, true);
			jjtc000 = false;
			if (p.hasConstantNamed(id.image) || p.hasFunctionNamed(id.image)
					|| p.hasODEVarNamed(id.image)
					|| p.hasFunctionWithArgNamed(id.image)) {
				if (true)
					throw new ParseException("Duplicate identifier: "
							+ id.image);
			}

			for (int i = 0; i < args.size(); i++) {
				if (p.hasConstantNamed((String) args.elementAt(i))
						|| p.hasFunctionNamed((String) args.elementAt(i))) {
					if (true)
						throw new ParseException("Duplicate identifier: "
								+ args.elementAt(i));
				}
			}

			p.addFunction(id.image, new UserDefinedFunction(args, jjtn000));
			jjtn000.dump("");
		} catch (Throwable jjte000) {
			if (jjtc000) {
				jjtree.clearNodeScope(jjtn000);
				jjtc000 = false;
			} else {
				jjtree.popNode();
			}
			if (jjte000 instanceof RuntimeException) {
				{
					if (true)
						throw (RuntimeException) jjte000;
				}
			}
			if (jjte000 instanceof ParseException) {
				{
					if (true)
						throw (ParseException) jjte000;
				}
			}
			{
				if (true)
					throw (Error) jjte000;
			}
		} finally {
			if (jjtc000) {
				jjtree.closeNodeScope(jjtn000, true);
			}
		}
	}

	final public void firstOrderODEDefinition(ParserInterface p)
	throws ParseException {
		/* @bgen(jjtree) FirstOrderODEDefinitionNode */
		ASTFirstOrderODEDefinitionNode jjtn000 = new ASTFirstOrderODEDefinitionNode(
				JJTFIRSTORDERODEDEFINITIONNODE);
		boolean jjtc000 = true;
		jjtree.openNodeScope(jjtn000);// Make a copy of the exact ODE string as
		// the user entered it later use

		Token id;
		// never used: Stack evalStack = new Stack();
		StringBuffer odeStringBuffer = new StringBuffer("");
		char temp = 'a';
		int count = 0;
		boolean done = false;

		do {
			try {
				temp = jj_input_stream.readChar();
			} catch (java.io.IOException e) {
				done = true;
				// System.out.println("ACK!!!!!!!!!!!!!!!");
			}
			count++;
			if (temp != '\n')
				odeStringBuffer.append(temp);
			else
				done = true;
		} while (!done);

		jj_input_stream.backup(count);
		try {
			id = jj_consume_token(ID);
			jj_consume_token(28);
			jj_consume_token(25);
			additiveExpression(p);
			jjtree.closeNodeScope(jjtn000, true);
			jjtc000 = false;
			if (p.hasConstantNamed(id.image) || p.hasFunctionNamed(id.image)
					|| p.hasODEVarNamed(id.image)) {
				if (true)
					throw new ParseException("Duplicate identifier: "
							+ id.image);
			}

			p.addFirstOrderODE(id.image, new String(odeStringBuffer), jjtn000);
			jjtn000.dump("");
		} catch (Throwable jjte000) {
			if (jjtc000) {
				jjtree.clearNodeScope(jjtn000);
				jjtc000 = false;
			} else {
				jjtree.popNode();
			}
			if (jjte000 instanceof RuntimeException) {
				{
					if (true)
						throw (RuntimeException) jjte000;
				}
			}
			if (jjte000 instanceof ParseException) {
				{
					if (true)
						throw (ParseException) jjte000;
				}
			}
			{
				if (true)
					throw (Error) jjte000;
			}
		} finally {
			if (jjtc000) {
				jjtree.closeNodeScope(jjtn000, true);
			}
		}
	}

	final public void orExpression(ParserInterface p) throws ParseException {
		andExpression(p);
		label_4: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 29:
				;
				break;
			default:
				jj_la1[6] = jj_gen;
				break label_4;
			}
			ASTBooleanOperatorNode jjtn001 = new ASTBooleanOperatorNode(
					JJTBOOLEANOPERATORNODE);
			boolean jjtc001 = true;
			jjtree.openNodeScope(jjtn001);
			try {
				jj_consume_token(29);
				andExpression(p);
				jjtree.closeNodeScope(jjtn001, 2);
				jjtc001 = false;
				jjtn001.setOperation(ParserInterface.OR);
			} catch (Throwable jjte001) {
				if (jjtc001) {
					jjtree.clearNodeScope(jjtn001);
					jjtc001 = false;
				} else {
					jjtree.popNode();
				}
				if (jjte001 instanceof RuntimeException) {
					{
						if (true)
							throw (RuntimeException) jjte001;
					}
				}
				if (jjte001 instanceof ParseException) {
					{
						if (true)
							throw (ParseException) jjte001;
					}
				}
				{
					if (true)
						throw (Error) jjte001;
				}
			} finally {
				if (jjtc001) {
					jjtree.closeNodeScope(jjtn001, 2);
				}
			}
		}
	}

	final public void andExpression(ParserInterface p) throws ParseException {
		relationalExpression(p);
		label_5: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 30:
				;
				break;
			default:
				jj_la1[7] = jj_gen;
				break label_5;
			}
			ASTBooleanOperatorNode jjtn001 = new ASTBooleanOperatorNode(
					JJTBOOLEANOPERATORNODE);
			boolean jjtc001 = true;
			jjtree.openNodeScope(jjtn001);
			try {
				jj_consume_token(30);
				relationalExpression(p);
				jjtree.closeNodeScope(jjtn001, 2);
				jjtc001 = false;
				jjtn001.setOperation(ParserInterface.AND);
			} catch (Throwable jjte001) {
				if (jjtc001) {
					jjtree.clearNodeScope(jjtn001);
					jjtc001 = false;
				} else {
					jjtree.popNode();
				}
				if (jjte001 instanceof RuntimeException) {
					{
						if (true)
							throw (RuntimeException) jjte001;
					}
				}
				if (jjte001 instanceof ParseException) {
					{
						if (true)
							throw (ParseException) jjte001;
					}
				}
				{
					if (true)
						throw (Error) jjte001;
				}
			} finally {
				if (jjtc001) {
					jjtree.closeNodeScope(jjtn001, 2);
				}
			}
		}
	}

	final public void relationalExpression(ParserInterface p)
	throws ParseException {
		if (jj_2_3(2147483647)) {
			jj_consume_token(26);
			orExpression(p);
			jj_consume_token(27);
		} else {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case MINUS:
			case NUMBER:
			case PIECEWISE:
			case ID:
			case 26:
				additiveExpression(p);
				switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
				case 31:
					ASTRelationalNode jjtn001 = new ASTRelationalNode(
							JJTRELATIONALNODE);
					boolean jjtc001 = true;
					jjtree.openNodeScope(jjtn001);
					try {
						jj_consume_token(31);
						additiveExpression(p);
						jjtree.closeNodeScope(jjtn001, 2);
						jjtc001 = false;
						jjtn001.setOperation(ParserInterface.EQUAL);
					} catch (Throwable jjte001) {
						if (jjtc001) {
							jjtree.clearNodeScope(jjtn001);
							jjtc001 = false;
						} else {
							jjtree.popNode();
						}
						if (jjte001 instanceof RuntimeException) {
							{
								if (true)
									throw (RuntimeException) jjte001;
							}
						}
						if (jjte001 instanceof ParseException) {
							{
								if (true)
									throw (ParseException) jjte001;
							}
						}
						{
							if (true)
								throw (Error) jjte001;
						}
					} finally {
						if (jjtc001) {
							jjtree.closeNodeScope(jjtn001, 2);
						}
					}
					break;
				case 32:
					ASTRelationalNode jjtn002 = new ASTRelationalNode(
							JJTRELATIONALNODE);
					boolean jjtc002 = true;
					jjtree.openNodeScope(jjtn002);
					try {
						jj_consume_token(32);
						additiveExpression(p);
						jjtree.closeNodeScope(jjtn002, 2);
						jjtc002 = false;
						jjtn002.setOperation(ParserInterface.NOT_EQUAL);
					} catch (Throwable jjte002) {
						if (jjtc002) {
							jjtree.clearNodeScope(jjtn002);
							jjtc002 = false;
						} else {
							jjtree.popNode();
						}
						if (jjte002 instanceof RuntimeException) {
							{
								if (true)
									throw (RuntimeException) jjte002;
							}
						}
						if (jjte002 instanceof ParseException) {
							{
								if (true)
									throw (ParseException) jjte002;
							}
						}
						{
							if (true)
								throw (Error) jjte002;
						}
					} finally {
						if (jjtc002) {
							jjtree.closeNodeScope(jjtn002, 2);
						}
					}
					break;
				case 33:
					ASTRelationalNode jjtn003 = new ASTRelationalNode(
							JJTRELATIONALNODE);
					boolean jjtc003 = true;
					jjtree.openNodeScope(jjtn003);
					try {
						jj_consume_token(33);
						additiveExpression(p);
						jjtree.closeNodeScope(jjtn003, 2);
						jjtc003 = false;
						jjtn003.setOperation(ParserInterface.LESS);
					} catch (Throwable jjte003) {
						if (jjtc003) {
							jjtree.clearNodeScope(jjtn003);
							jjtc003 = false;
						} else {
							jjtree.popNode();
						}
						if (jjte003 instanceof RuntimeException) {
							{
								if (true)
									throw (RuntimeException) jjte003;
							}
						}
						if (jjte003 instanceof ParseException) {
							{
								if (true)
									throw (ParseException) jjte003;
							}
						}
						{
							if (true)
								throw (Error) jjte003;
						}
					} finally {
						if (jjtc003) {
							jjtree.closeNodeScope(jjtn003, 2);
						}
					}
					break;
				case 34:
					ASTRelationalNode jjtn004 = new ASTRelationalNode(
							JJTRELATIONALNODE);
					boolean jjtc004 = true;
					jjtree.openNodeScope(jjtn004);
					try {
						jj_consume_token(34);
						additiveExpression(p);
						jjtree.closeNodeScope(jjtn004, 2);
						jjtc004 = false;
						jjtn004.setOperation(ParserInterface.GREATER);
					} catch (Throwable jjte004) {
						if (jjtc004) {
							jjtree.clearNodeScope(jjtn004);
							jjtc004 = false;
						} else {
							jjtree.popNode();
						}
						if (jjte004 instanceof RuntimeException) {
							{
								if (true)
									throw (RuntimeException) jjte004;
							}
						}
						if (jjte004 instanceof ParseException) {
							{
								if (true)
									throw (ParseException) jjte004;
							}
						}
						{
							if (true)
								throw (Error) jjte004;
						}
					} finally {
						if (jjtc004) {
							jjtree.closeNodeScope(jjtn004, 2);
						}
					}
					break;
				case 35:
					ASTRelationalNode jjtn005 = new ASTRelationalNode(
							JJTRELATIONALNODE);
					boolean jjtc005 = true;
					jjtree.openNodeScope(jjtn005);
					try {
						jj_consume_token(35);
						additiveExpression(p);
						jjtree.closeNodeScope(jjtn005, 2);
						jjtc005 = false;
						jjtn005.setOperation(ParserInterface.LESS_OR_EQUAL);
					} catch (Throwable jjte005) {
						if (jjtc005) {
							jjtree.clearNodeScope(jjtn005);
							jjtc005 = false;
						} else {
							jjtree.popNode();
						}
						if (jjte005 instanceof RuntimeException) {
							{
								if (true)
									throw (RuntimeException) jjte005;
							}
						}
						if (jjte005 instanceof ParseException) {
							{
								if (true)
									throw (ParseException) jjte005;
							}
						}
						{
							if (true)
								throw (Error) jjte005;
						}
					} finally {
						if (jjtc005) {
							jjtree.closeNodeScope(jjtn005, 2);
						}
					}
					break;
				case 36:
					ASTRelationalNode jjtn006 = new ASTRelationalNode(
							JJTRELATIONALNODE);
					boolean jjtc006 = true;
					jjtree.openNodeScope(jjtn006);
					try {
						jj_consume_token(36);
						additiveExpression(p);
						jjtree.closeNodeScope(jjtn006, 2);
						jjtc006 = false;
						jjtn006.setOperation(ParserInterface.GREATER_OR_EQUAL);
					} catch (Throwable jjte006) {
						if (jjtc006) {
							jjtree.clearNodeScope(jjtn006);
							jjtc006 = false;
						} else {
							jjtree.popNode();
						}
						if (jjte006 instanceof RuntimeException) {
							{
								if (true)
									throw (RuntimeException) jjte006;
							}
						}
						if (jjte006 instanceof ParseException) {
							{
								if (true)
									throw (ParseException) jjte006;
							}
						}
						{
							if (true)
								throw (Error) jjte006;
						}
					} finally {
						if (jjtc006) {
							jjtree.closeNodeScope(jjtn006, 2);
						}
					}
					break;
				default:
					jj_la1[8] = jj_gen;
					jj_consume_token(-1);
					throw new ParseException();
				}
				break;
			default:
				jj_la1[9] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
			}
		}
	}

	final public void additiveExpression(ParserInterface p)
	throws ParseException {
		multiplicativeExpression(p);
		label_6: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case PLUS:
			case MINUS:
				;
				break;
			default:
				jj_la1[10] = jj_gen;
				break label_6;
			}
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case PLUS:
				ASTOperatorNode jjtn001 = new ASTOperatorNode(JJTOPERATORNODE);
				boolean jjtc001 = true;
				jjtree.openNodeScope(jjtn001);
				try {
					jj_consume_token(PLUS);
					multiplicativeExpression(p);
					jjtree.closeNodeScope(jjtn001, 2);
					jjtc001 = false;
					jjtn001.setOperation(ParserInterface.ADD);
				} catch (Throwable jjte001) {
					if (jjtc001) {
						jjtree.clearNodeScope(jjtn001);
						jjtc001 = false;
					} else {
						jjtree.popNode();
					}
					if (jjte001 instanceof RuntimeException) {
						{
							if (true)
								throw (RuntimeException) jjte001;
						}
					}
					if (jjte001 instanceof ParseException) {
						{
							if (true)
								throw (ParseException) jjte001;
						}
					}
					{
						if (true)
							throw (Error) jjte001;
					}
				} finally {
					if (jjtc001) {
						jjtree.closeNodeScope(jjtn001, 2);
					}
				}
				break;
			case MINUS:
				ASTOperatorNode jjtn002 = new ASTOperatorNode(JJTOPERATORNODE);
				boolean jjtc002 = true;
				jjtree.openNodeScope(jjtn002);
				try {
					jj_consume_token(MINUS);
					multiplicativeExpression(p);
					jjtree.closeNodeScope(jjtn002, 2);
					jjtc002 = false;
					jjtn002.setOperation(ParserInterface.SUBTRACT);
				} catch (Throwable jjte002) {
					if (jjtc002) {
						jjtree.clearNodeScope(jjtn002);
						jjtc002 = false;
					} else {
						jjtree.popNode();
					}
					if (jjte002 instanceof RuntimeException) {
						{
							if (true)
								throw (RuntimeException) jjte002;
						}
					}
					if (jjte002 instanceof ParseException) {
						{
							if (true)
								throw (ParseException) jjte002;
						}
					}
					{
						if (true)
							throw (Error) jjte002;
					}
				} finally {
					if (jjtc002) {
						jjtree.closeNodeScope(jjtn002, 2);
					}
				}
				break;
			default:
				jj_la1[11] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
			}
		}
	}

	final public void multiplicativeExpression(ParserInterface p)
	throws ParseException {
		unaryExpression(p);
		label_7: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case MULTIPLY:
			case DIVIDE:
			case MOD:
				;
				break;
			default:
				jj_la1[12] = jj_gen;
				break label_7;
			}
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case MULTIPLY:
				ASTOperatorNode jjtn001 = new ASTOperatorNode(JJTOPERATORNODE);
				boolean jjtc001 = true;
				jjtree.openNodeScope(jjtn001);
				try {
					jj_consume_token(MULTIPLY);
					unaryExpression(p);
					jjtree.closeNodeScope(jjtn001, 2);
					jjtc001 = false;
					jjtn001.setOperation(ParserInterface.MULTIPLY);
				} catch (Throwable jjte001) {
					if (jjtc001) {
						jjtree.clearNodeScope(jjtn001);
						jjtc001 = false;
					} else {
						jjtree.popNode();
					}
					if (jjte001 instanceof RuntimeException) {
						{
							if (true)
								throw (RuntimeException) jjte001;
						}
					}
					if (jjte001 instanceof ParseException) {
						{
							if (true)
								throw (ParseException) jjte001;
						}
					}
					{
						if (true)
							throw (Error) jjte001;
					}
				} finally {
					if (jjtc001) {
						jjtree.closeNodeScope(jjtn001, 2);
					}
				}
				break;
			case DIVIDE:
				ASTOperatorNode jjtn002 = new ASTOperatorNode(JJTOPERATORNODE);
				boolean jjtc002 = true;
				jjtree.openNodeScope(jjtn002);
				try {
					jj_consume_token(DIVIDE);
					unaryExpression(p);
					jjtree.closeNodeScope(jjtn002, 2);
					jjtc002 = false;
					jjtn002.setOperation(ParserInterface.DIVIDE);
				} catch (Throwable jjte002) {
					if (jjtc002) {
						jjtree.clearNodeScope(jjtn002);
						jjtc002 = false;
					} else {
						jjtree.popNode();
					}
					if (jjte002 instanceof RuntimeException) {
						{
							if (true)
								throw (RuntimeException) jjte002;
						}
					}
					if (jjte002 instanceof ParseException) {
						{
							if (true)
								throw (ParseException) jjte002;
						}
					}
					{
						if (true)
							throw (Error) jjte002;
					}
				} finally {
					if (jjtc002) {
						jjtree.closeNodeScope(jjtn002, 2);
					}
				}
				break;
			case MOD:
				ASTOperatorNode jjtn003 = new ASTOperatorNode(JJTOPERATORNODE);
				boolean jjtc003 = true;
				jjtree.openNodeScope(jjtn003);
				try {
					jj_consume_token(MOD);
					unaryExpression(p);
					jjtree.closeNodeScope(jjtn003, 2);
					jjtc003 = false;
					jjtn003.setOperation(ParserInterface.REMAINDER);
				} catch (Throwable jjte003) {
					if (jjtc003) {
						jjtree.clearNodeScope(jjtn003);
						jjtc003 = false;
					} else {
						jjtree.popNode();
					}
					if (jjte003 instanceof RuntimeException) {
						{
							if (true)
								throw (RuntimeException) jjte003;
						}
					}
					if (jjte003 instanceof ParseException) {
						{
							if (true)
								throw (ParseException) jjte003;
						}
					}
					{
						if (true)
							throw (Error) jjte003;
					}
				} finally {
					if (jjtc003) {
						jjtree.closeNodeScope(jjtn003, 2);
					}
				}
				break;
			default:
				jj_la1[13] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
			}
		}
	}

	final public void unaryExpression(ParserInterface p) throws ParseException {
		switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
		case MINUS:
			ASTOperatorNode jjtn001 = new ASTOperatorNode(JJTOPERATORNODE);
			boolean jjtc001 = true;
			jjtree.openNodeScope(jjtn001);
			try {
				jj_consume_token(MINUS);
				unaryExpression(p);
				jjtree.closeNodeScope(jjtn001, 1);
				jjtc001 = false;
				jjtn001.setOperation(ParserInterface.NEGATION);
			} catch (Throwable jjte001) {
				if (jjtc001) {
					jjtree.clearNodeScope(jjtn001);
					jjtc001 = false;
				} else {
					jjtree.popNode();
				}
				if (jjte001 instanceof RuntimeException) {
					{
						if (true)
							throw (RuntimeException) jjte001;
					}
				}
				if (jjte001 instanceof ParseException) {
					{
						if (true)
							throw (ParseException) jjte001;
					}
				}
				{
					if (true)
						throw (Error) jjte001;
				}
			} finally {
				if (jjtc001) {
					jjtree.closeNodeScope(jjtn001, 1);
				}
			}
			break;
		case NUMBER:
		case PIECEWISE:
		case ID:
		case 26:
			powerExpression(p);
			break;
		default:
			jj_la1[14] = jj_gen;
			jj_consume_token(-1);
			throw new ParseException();
		}
	}

	final public void powerExpression(ParserInterface p) throws ParseException {
		unaryExpressionNotPlusMinus(p);
		switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
		case EXP:
			ASTOperatorNode jjtn001 = new ASTOperatorNode(JJTOPERATORNODE);
			boolean jjtc001 = true;
			jjtree.openNodeScope(jjtn001);
			try {
				jj_consume_token(EXP);
				unaryExpression(p);
				jjtree.closeNodeScope(jjtn001, 2);
				jjtc001 = false;
				jjtn001.setOperation(ParserInterface.POWER);
			} catch (Throwable jjte001) {
				if (jjtc001) {
					jjtree.clearNodeScope(jjtn001);
					jjtc001 = false;
				} else {
					jjtree.popNode();
				}
				if (jjte001 instanceof RuntimeException) {
					{
						if (true)
							throw (RuntimeException) jjte001;
					}
				}
				if (jjte001 instanceof ParseException) {
					{
						if (true)
							throw (ParseException) jjte001;
					}
				}
				{
					if (true)
						throw (Error) jjte001;
				}
			} finally {
				if (jjtc001) {
					jjtree.closeNodeScope(jjtn001, 2);
				}
			}
			break;
		default:
			jj_la1[15] = jj_gen;
			;
		}
	}

	final public void unaryExpressionNotPlusMinus(ParserInterface p)
	throws ParseException {
		switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
		case NUMBER:
		case PIECEWISE:
		case ID:
			element(p);
			break;
		case 26:
			jj_consume_token(26);
			additiveExpression(p);
			jj_consume_token(27);
			break;
		default:
			jj_la1[16] = jj_gen;
			jj_consume_token(-1);
			throw new ParseException();
		}
	}

	final public void element(ParserInterface p) throws ParseException {
		if (jj_2_4(2147483647)) {
			piecewiseExpression(p);
		} else if (jj_2_5(2)) {
			function(p);
		} else {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case ID:
				identifier(p);
				break;
			case NUMBER:
				number(p);
				break;
			default:
				jj_la1[17] = jj_gen;
				jj_consume_token(-1);
				throw new ParseException();
			}
		}
	}

	final public void piecewiseExpression(ParserInterface p)
	throws ParseException {
		/* @bgen(jjtree) PiecewiseNode */
		ASTPiecewiseNode jjtn000 = new ASTPiecewiseNode(JJTPIECEWISENODE);
		boolean jjtc000 = true;
		jjtree.openNodeScope(jjtn000);
		try {
			jj_consume_token(PIECEWISE);
			jj_consume_token(26);
			orExpression(p);
			jj_consume_token(37);
			additiveExpression(p);
			label_8: while (true) {
				if (jj_2_6(2147483647)) {
					;
				} else {
					break label_8;
				}
				jj_consume_token(37);
				orExpression(p);
				jj_consume_token(37);
				additiveExpression(p);
			}
			if (jj_2_7(2147483647)) {
				jj_consume_token(37);
				additiveExpression(p);
			} else {
				;
			}
			jj_consume_token(27);
		} catch (Throwable jjte000) {
			if (jjtc000) {
				jjtree.clearNodeScope(jjtn000);
				jjtc000 = false;
			} else {
				jjtree.popNode();
			}
			if (jjte000 instanceof RuntimeException) {
				{
					if (true)
						throw (RuntimeException) jjte000;
				}
			}
			if (jjte000 instanceof ParseException) {
				{
					if (true)
						throw (ParseException) jjte000;
				}
			}
			{
				if (true)
					throw (Error) jjte000;
			}
		} finally {
			if (jjtc000) {
				jjtree.closeNodeScope(jjtn000, true);
			}
		}
	}

	final public void function(ParserInterface p) throws ParseException {
		Token id;
		ASTFunctionNode jjtn001 = new ASTFunctionNode(JJTFUNCTIONNODE);
		boolean jjtc001 = true;
		jjtree.openNodeScope(jjtn001);
		try {
			id = jj_consume_token(ID);
			jjtn001.setName(id.image);
			jj_consume_token(26);
			additiveExpression(p);
			label_9: while (true) {
				switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
				case 37:
					;
					break;
				default:
					jj_la1[18] = jj_gen;
					break label_9;
				}
				jj_consume_token(37);
				additiveExpression(p);
			}
			jj_consume_token(27);
		} catch (Throwable jjte001) {
			if (jjtc001) {
				jjtree.clearNodeScope(jjtn001);
				jjtc001 = false;
			} else {
				jjtree.popNode();
			}
			if (jjte001 instanceof RuntimeException) {
				{
					if (true)
						throw (RuntimeException) jjte001;
				}
			}
			if (jjte001 instanceof ParseException) {
				{
					if (true)
						throw (ParseException) jjte001;
				}
			}
			{
				if (true)
					throw (Error) jjte001;
			}
		} finally {
			if (jjtc001) {
				jjtree.closeNodeScope(jjtn001, true);
			}
		}
	}

	@SuppressWarnings("unchecked")
	final public void definitionArgumentList(Vector args, ParserInterface p)
	throws ParseException {
		Token id;
		id = jj_consume_token(ID);
		args.add(id.image);
		label_10: while (true) {
			switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
			case 37:
				;
				break;
			default:
				jj_la1[19] = jj_gen;
				break label_10;
			}
			jj_consume_token(37);
			id = jj_consume_token(ID);
			args.add(id.image);
		}
	}

	final public void number(ParserInterface p) throws ParseException {
		Token num;
		num = jj_consume_token(NUMBER);
		ASTNumberNode jjtn001 = new ASTNumberNode(JJTNUMBERNODE);
		boolean jjtc001 = true;
		jjtree.openNodeScope(jjtn001);
		try {
			jjtree.closeNodeScope(jjtn001, 0);
			jjtc001 = false;
			jjtn001.setValue(Double.parseDouble(num.image));
		} finally {
			if (jjtc001) {
				jjtree.closeNodeScope(jjtn001, 0);
			}
		}
	}

	final public void identifier(ParserInterface p) throws ParseException {
		Token id, prime = null;
		id = jj_consume_token(ID);
		switch ((jj_ntk == -1) ? jj_ntk() : jj_ntk) {
		case 28:
			prime = jj_consume_token(28);
			break;
		default:
			jj_la1[20] = jj_gen;
			;
		}
		ASTIdentifierNode jjtn001 = new ASTIdentifierNode(JJTIDENTIFIERNODE);
		boolean jjtc001 = true;
		jjtree.openNodeScope(jjtn001);
		try {
			jjtree.closeNodeScope(jjtn001, 0);
			jjtc001 = false;
			jjtn001.setName(id.image);
			if (prime != null)
				jjtn001.setPrimed(true);
			else
				jjtn001.setPrimed(false);
		} finally {
			if (jjtc001) {
				jjtree.closeNodeScope(jjtn001, 0);
			}
		}
	}

	final private boolean jj_2_1(int xla) {
		jj_la = xla;
		jj_lastpos = jj_scanpos = token;
		boolean retval = !jj_3_1();
		jj_save(0, xla);
		return retval;
	}

	final private boolean jj_2_2(int xla) {
		jj_la = xla;
		jj_lastpos = jj_scanpos = token;
		boolean retval = !jj_3_2();
		jj_save(1, xla);
		return retval;
	}

	final private boolean jj_2_3(int xla) {
		jj_la = xla;
		jj_lastpos = jj_scanpos = token;
		boolean retval = !jj_3_3();
		jj_save(2, xla);
		return retval;
	}

	final private boolean jj_2_4(int xla) {
		jj_la = xla;
		jj_lastpos = jj_scanpos = token;
		boolean retval = !jj_3_4();
		jj_save(3, xla);
		return retval;
	}

	final private boolean jj_2_5(int xla) {
		jj_la = xla;
		jj_lastpos = jj_scanpos = token;
		boolean retval = !jj_3_5();
		jj_save(4, xla);
		return retval;
	}

	final private boolean jj_2_6(int xla) {
		jj_la = xla;
		jj_lastpos = jj_scanpos = token;
		boolean retval = !jj_3_6();
		jj_save(5, xla);
		return retval;
	}

	final private boolean jj_2_7(int xla) {
		jj_la = xla;
		jj_lastpos = jj_scanpos = token;
		boolean retval = !jj_3_7();
		jj_save(6, xla);
		return retval;
	}

	final private boolean jj_3_7() {
		if (jj_scan_token(37))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3_6() {
		if (jj_scan_token(37))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_13())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_25() {
		if (jj_scan_token(MINUS))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_18())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_14() {
		if (jj_scan_token(ID))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(26))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		while (true) {
			xsp = jj_scanpos;
			if (jj_3R_53()) {
				jj_scanpos = xsp;
				break;
			}
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		}
		if (jj_scan_token(27))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_12() {
		if (jj_scan_token(ID))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(28))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_52() {
		if (jj_scan_token(37))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_51() {
		if (jj_scan_token(37))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_13())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(37))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_19() {
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_24()) {
			jj_scanpos = xsp;
			if (jj_3R_25())
				return true;
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_24() {
		if (jj_scan_token(PLUS))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_18())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_48() {
		if (jj_scan_token(PIECEWISE))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(26))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_13())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(37))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		while (true) {
			xsp = jj_scanpos;
			if (jj_3R_51()) {
				jj_scanpos = xsp;
				break;
			}
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		}
		xsp = jj_scanpos;
		if (jj_3R_52())
			jj_scanpos = xsp;
		else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(27))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_15() {
		if (jj_3R_18())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		while (true) {
			xsp = jj_scanpos;
			if (jj_3R_19()) {
				jj_scanpos = xsp;
				break;
			}
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		}
		return false;
	}

	final private boolean jj_3_4() {
		if (jj_scan_token(PIECEWISE))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3_5() {
		if (jj_3R_14())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_45() {
		if (jj_3R_48())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_44() {
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_45()) {
			jj_scanpos = xsp;
			if (jj_3_5()) {
				jj_scanpos = xsp;
				if (jj_3R_46()) {
					jj_scanpos = xsp;
					if (jj_3R_47())
						return true;
					if (jj_la == 0 && jj_scanpos == jj_lastpos)
						return false;
				} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
					return false;
			} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_43() {
		if (jj_scan_token(26))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(27))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_38() {
		if (jj_scan_token(36))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_42() {
		if (jj_3R_44())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_40() {
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_42()) {
			jj_scanpos = xsp;
			if (jj_3R_43())
				return true;
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_37() {
		if (jj_scan_token(35))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_36() {
		if (jj_scan_token(34))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_35() {
		if (jj_scan_token(33))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_41() {
		if (jj_scan_token(EXP))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_22())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_39() {
		if (jj_3R_40())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_41())
			jj_scanpos = xsp;
		else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_34() {
		if (jj_scan_token(32))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3_3() {
		if (jj_scan_token(26))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_13())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_11() {
		if (jj_scan_token(ID))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(26))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_33() {
		if (jj_scan_token(31))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_29() {
		if (jj_3R_39())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_27() {
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_33()) {
			jj_scanpos = xsp;
			if (jj_3R_34()) {
				jj_scanpos = xsp;
				if (jj_3R_35()) {
					jj_scanpos = xsp;
					if (jj_3R_36()) {
						jj_scanpos = xsp;
						if (jj_3R_37()) {
							jj_scanpos = xsp;
							if (jj_3R_38())
								return true;
							if (jj_la == 0 && jj_scanpos == jj_lastpos)
								return false;
						} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
							return false;
					} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
						return false;
				} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
					return false;
			} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_20() {
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_26()) {
			jj_scanpos = xsp;
			if (jj_3R_27())
				return true;
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_26() {
		if (jj_scan_token(26))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_13())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_scan_token(27))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_53() {
		if (jj_scan_token(37))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_15())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_22() {
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_28()) {
			jj_scanpos = xsp;
			if (jj_3R_29())
				return true;
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_28() {
		if (jj_scan_token(MINUS))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_22())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_54() {
		if (jj_scan_token(28))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_21() {
		if (jj_scan_token(30))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_20())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_16() {
		if (jj_3R_20())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		while (true) {
			xsp = jj_scanpos;
			if (jj_3R_21()) {
				jj_scanpos = xsp;
				break;
			}
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		}
		return false;
	}

	final private boolean jj_3R_47() {
		if (jj_3R_50())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_32() {
		if (jj_scan_token(MOD))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_22())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_49() {
		if (jj_scan_token(ID))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_54())
			jj_scanpos = xsp;
		else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3_2() {
		if (jj_3R_12())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_17() {
		if (jj_scan_token(29))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_16())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_31() {
		if (jj_scan_token(DIVIDE))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_22())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3_1() {
		if (jj_3R_11())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_13() {
		if (jj_3R_16())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		while (true) {
			xsp = jj_scanpos;
			if (jj_3R_17()) {
				jj_scanpos = xsp;
				break;
			}
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		}
		return false;
	}

	final private boolean jj_3R_50() {
		if (jj_scan_token(NUMBER))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_23() {
		Token xsp;
		xsp = jj_scanpos;
		if (jj_3R_30()) {
			jj_scanpos = xsp;
			if (jj_3R_31()) {
				jj_scanpos = xsp;
				if (jj_3R_32())
					return true;
				if (jj_la == 0 && jj_scanpos == jj_lastpos)
					return false;
			} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		} else if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_30() {
		if (jj_scan_token(MULTIPLY))
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		if (jj_3R_22())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_46() {
		if (jj_3R_49())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		return false;
	}

	final private boolean jj_3R_18() {
		if (jj_3R_22())
			return true;
		if (jj_la == 0 && jj_scanpos == jj_lastpos)
			return false;
		Token xsp;
		while (true) {
			xsp = jj_scanpos;
			if (jj_3R_23()) {
				jj_scanpos = xsp;
				break;
			}
			if (jj_la == 0 && jj_scanpos == jj_lastpos)
				return false;
		}
		return false;
	}

	public ParserTokenManager token_source;
	SimpleCharStream jj_input_stream;
	public Token token, jj_nt;
	private int jj_ntk;
	private Token jj_scanpos, jj_lastpos;
	private int jj_la;
	public boolean lookingAhead = false;
	@SuppressWarnings("unused")
	private boolean jj_semLA;
	private int jj_gen;
	final private int[] jj_la1 = new int[21];
	final private int[] jj_la1_0 = { 0x1800000, 0x1800000, 0x200000, 0x200000,
			0x1800000, 0x1800000, 0x20000000, 0x40000000, 0x80000000,
			0x4310800, 0xc00, 0xc00, 0x7000, 0x7000, 0x4310800, 0x8000,
			0x4310000, 0x210000, 0x0, 0x0, 0x10000000, };
	final private int[] jj_la1_1 = { 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
			0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x20, 0x0, };
	final private JJCalls[] jj_2_rtns = new JJCalls[7];
	private boolean jj_rescan = false;
	private int jj_gc = 0;

	public Parser(java.io.InputStream stream) {
		jj_input_stream = new SimpleCharStream(stream, 1, 1);
		token_source = new ParserTokenManager(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 21; i++)
			jj_la1[i] = -1;
		for (int i = 0; i < jj_2_rtns.length; i++)
			jj_2_rtns[i] = new JJCalls();
	}

	public void ReInit(java.io.InputStream stream) {
		jj_input_stream.ReInit(stream, 1, 1);
		token_source.ReInit(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jjtree.reset();
		jj_gen = 0;
		for (int i = 0; i < 21; i++)
			jj_la1[i] = -1;
		for (int i = 0; i < jj_2_rtns.length; i++)
			jj_2_rtns[i] = new JJCalls();
	}

	public Parser(java.io.Reader stream) {
		jj_input_stream = new SimpleCharStream(stream, 1, 1);
		token_source = new ParserTokenManager(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 21; i++)
			jj_la1[i] = -1;
		for (int i = 0; i < jj_2_rtns.length; i++)
			jj_2_rtns[i] = new JJCalls();
	}

	public void ReInit(java.io.Reader stream) {
		jj_input_stream.ReInit(stream, 1, 1);
		token_source.ReInit(jj_input_stream);
		token = new Token();
		jj_ntk = -1;
		jjtree.reset();
		jj_gen = 0;
		for (int i = 0; i < 21; i++)
			jj_la1[i] = -1;
		for (int i = 0; i < jj_2_rtns.length; i++)
			jj_2_rtns[i] = new JJCalls();
	}

	public Parser(ParserTokenManager tm) {
		token_source = tm;
		token = new Token();
		jj_ntk = -1;
		jj_gen = 0;
		for (int i = 0; i < 21; i++)
			jj_la1[i] = -1;
		for (int i = 0; i < jj_2_rtns.length; i++)
			jj_2_rtns[i] = new JJCalls();
	}

	public void ReInit(ParserTokenManager tm) {
		token_source = tm;
		token = new Token();
		jj_ntk = -1;
		jjtree.reset();
		jj_gen = 0;
		for (int i = 0; i < 21; i++)
			jj_la1[i] = -1;
		for (int i = 0; i < jj_2_rtns.length; i++)
			jj_2_rtns[i] = new JJCalls();
	}

	final private Token jj_consume_token(int kind) throws ParseException {
		Token oldToken;
		if ((oldToken = token).next != null)
			token = token.next;
		else
			token = token.next = token_source.getNextToken();
		jj_ntk = -1;
		if (token.kind == kind) {
			jj_gen++;
			if (++jj_gc > 100) {
				jj_gc = 0;
				for (int i = 0; i < jj_2_rtns.length; i++) {
					JJCalls c = jj_2_rtns[i];
					while (c != null) {
						if (c.gen < jj_gen)
							c.first = null;
						c = c.next;
					}
				}
			}
			return token;
		}
		token = oldToken;
		jj_kind = kind;
		throw generateParseException();
	}

	final private boolean jj_scan_token(int kind) {
		if (jj_scanpos == jj_lastpos) {
			jj_la--;
			if (jj_scanpos.next == null) {
				jj_lastpos = jj_scanpos = jj_scanpos.next = token_source
				.getNextToken();
			} else {
				jj_lastpos = jj_scanpos = jj_scanpos.next;
			}
		} else {
			jj_scanpos = jj_scanpos.next;
		}
		if (jj_rescan) {
			int i = 0;
			Token tok = token;
			while (tok != null && tok != jj_scanpos) {
				i++;
				tok = tok.next;
			}
			if (tok != null)
				jj_add_error_token(kind, i);
		}
		return (jj_scanpos.kind != kind);
	}

	final public Token getNextToken() {
		if (token.next != null)
			token = token.next;
		else
			token = token.next = token_source.getNextToken();
		jj_ntk = -1;
		jj_gen++;
		return token;
	}

	final public Token getToken(int index) {
		Token t = lookingAhead ? jj_scanpos : token;
		for (int i = 0; i < index; i++) {
			if (t.next != null)
				t = t.next;
			else
				t = t.next = token_source.getNextToken();
		}
		return t;
	}

	final private int jj_ntk() {
		if ((jj_nt = token.next) == null)
			return (jj_ntk = (token.next = token_source.getNextToken()).kind);
		else
			return (jj_ntk = jj_nt.kind);
	}

	@SuppressWarnings("unchecked")
	private java.util.Vector jj_expentries = new java.util.Vector();
	private int[] jj_expentry;
	private int jj_kind = -1;
	private int[] jj_lasttokens = new int[100];
	private int jj_endpos;

	@SuppressWarnings("unchecked")
	private void jj_add_error_token(int kind, int pos) {
		if (pos >= 100)
			return;
		if (pos == jj_endpos + 1) {
			jj_lasttokens[jj_endpos++] = kind;
		} else if (jj_endpos != 0) {
			jj_expentry = new int[jj_endpos];
			for (int i = 0; i < jj_endpos; i++) {
				jj_expentry[i] = jj_lasttokens[i];
			}
			boolean exists = false;
			for (java.util.Enumeration enum_ = jj_expentries.elements(); enum_
			.hasMoreElements();) {
				int[] oldentry = (int[]) (enum_.nextElement());
				if (oldentry.length == jj_expentry.length) {
					exists = true;
					for (int i = 0; i < jj_expentry.length; i++) {
						if (oldentry[i] != jj_expentry[i]) {
							exists = false;
							break;
						}
					}
					if (exists)
						break;
				}
			}
			if (!exists)
				jj_expentries.addElement(jj_expentry);
			if (pos != 0)
				jj_lasttokens[(jj_endpos = pos) - 1] = kind;
		}
	}

	@SuppressWarnings("unchecked")
	final public ParseException generateParseException() {
		jj_expentries.removeAllElements();
		boolean[] la1tokens = new boolean[38];
		for (int i = 0; i < 38; i++) {
			la1tokens[i] = false;
		}
		if (jj_kind >= 0) {
			la1tokens[jj_kind] = true;
			jj_kind = -1;
		}
		for (int i = 0; i < 21; i++) {
			if (jj_la1[i] == jj_gen) {
				for (int j = 0; j < 32; j++) {
					if ((jj_la1_0[i] & (1 << j)) != 0) {
						la1tokens[j] = true;
					}
					if ((jj_la1_1[i] & (1 << j)) != 0) {
						la1tokens[32 + j] = true;
					}
				}
			}
		}
		for (int i = 0; i < 38; i++) {
			if (la1tokens[i]) {
				jj_expentry = new int[1];
				jj_expentry[0] = i;
				jj_expentries.addElement(jj_expentry);
			}
		}
		jj_endpos = 0;
		jj_rescan_token();
		jj_add_error_token(0, 0);
		int[][] exptokseq = new int[jj_expentries.size()][];
		for (int i = 0; i < jj_expentries.size(); i++) {
			exptokseq[i] = (int[]) jj_expentries.elementAt(i);
		}
		return new ParseException(token, exptokseq, tokenImage);
	}

	final public void enable_tracing() {
	}

	final public void disable_tracing() {
	}

	final private void jj_rescan_token() {
		jj_rescan = true;
		for (int i = 0; i < 7; i++) {
			JJCalls p = jj_2_rtns[i];
			do {
				if (p.gen > jj_gen) {
					jj_la = p.arg;
					jj_lastpos = jj_scanpos = p.first;
					switch (i) {
					case 0:
						jj_3_1();
						break;
					case 1:
						jj_3_2();
						break;
					case 2:
						jj_3_3();
						break;
					case 3:
						jj_3_4();
						break;
					case 4:
						jj_3_5();
						break;
					case 5:
						jj_3_6();
						break;
					case 6:
						jj_3_7();
						break;
					}
				}
				p = p.next;
			} while (p != null);
		}
		jj_rescan = false;
	}

	final private void jj_save(int index, int xla) {
		JJCalls p = jj_2_rtns[index];
		while (p.gen > jj_gen) {
			if (p.next == null) {
				p = p.next = new JJCalls();
				break;
			}
			p = p.next;
		}
		p.gen = jj_gen + xla - jj_la;
		p.first = token;
		p.arg = xla;
	}

	static final class JJCalls {
		int gen;
		Token first;
		int arg;
		JJCalls next;
	}

}
