/*******************************************************************************
 * This file is part of ODE Toolkit: a free application for solving systems of
 * ordinary differential equations.
 *  
 * Copyright (C) 2002-2011 Max Comstock, Beky Kotcon, Samantha Mesuro, Daniel Rozenfeld,
 * Anak Yodpinyanee, Andres Perez, Eric Doi, Richard Mehlinger, Steven Ehrlich,
 * Martin Hunt, George Tucker, Peter Scherpelz, Aaron Becker, Eric Harley,
 * Chris Moore
 * 
 * ODE Toolkit is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * 
 * ODE Toolkit is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * ODE Toolkit.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/

/* Generated By:JJTree: Do not edit this line. ASTBooleanOperatorNode.java */

package parser.nodes;

import parser.ParseException;
import parser.Parser;
import parser.ParserInterface;

public class ASTBooleanOperatorNode extends SimpleNode {

	private short operation;

	public ASTBooleanOperatorNode(int id) {
		super(id);
	}

	public ASTBooleanOperatorNode(Parser p, int id) {
		super(p, id);
	}

	public void setOperation(short op) {
		operation = op;
	}

	@Override
	public double evaluate(ParserInterface p) throws ParseException {
		throw new ParseException("evaluate() called on a boolean node");
	}

	@Override
	public boolean evaluateBoolean(ParserInterface p) throws ParseException {
		switch (operation) {
		case ParserInterface.AND:
			return children[0].evaluateBoolean(p)
			&& children[1].evaluateBoolean(p);
		case ParserInterface.OR:
			return children[0].evaluateBoolean(p)
			|| children[1].evaluateBoolean(p);
		default:
			throw new ParseException(
					"Unrecognized operation in BooleanOperatorNode");
		}
	}

	@Override
	public void checkIdentifiers(ParserInterface p) throws ParseException {
		children[0].checkIdentifiers(p);
		children[1].checkIdentifiers(p);
	}

}
