/*******************************************************************************
 * This file is part of ODE Toolkit: a free application for solving systems of
 * ordinary differential equations.
 *  
 * Copyright (C) 2002-2011 Max Comstock, Beky Kotcon, Samantha Mesuro, Daniel Rozenfeld,
 * Anak Yodpinyanee, Andres Perez, Eric Doi, Richard Mehlinger, Steven Ehrlich,
 * Martin Hunt, George Tucker, Peter Scherpelz, Aaron Becker, Eric Harley,
 * Chris Moore
 * 
 * ODE Toolkit is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * 
 * ODE Toolkit is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * ODE Toolkit.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/

/* Generated By:JJTree: Do not edit this line. ASTFunctionNode.java */

package parser.nodes;

import parser.ParseException;
import parser.Parser;
import parser.ParserInterface;

public class ASTFunctionNode extends SimpleNode {
	private String name;
	private double[] args;

	public ASTFunctionNode(int id) {
		super(id);
		args = null;
	}

	public ASTFunctionNode(Parser p, int id) {
		super(p, id);
		args = null;
	}

	public void setName(String s) {
		name = s;
	}

	@Override
	public double evaluate(ParserInterface p) throws ParseException {
		if (args == null) {
			args = new double[p.getNumArgsToFunction(name)];
			if (children.length != args.length)
				throw new ParseException(
						"Incorrect number of arguments passed to function "
						+ name);
		}
		for (int i = 0; i < children.length; i++)
			args[i] = children[i].evaluate(p);
		return p.evaluateFunction(name, args);
	}

	@Override
	public boolean evaluateBoolean(ParserInterface p) throws ParseException {
		throw new ParseException("evaluateBoolean() called on non-boolean node");
	}

	@Override
	public void checkIdentifiers(ParserInterface p) throws ParseException {
		if (!p.hasFunctionNamed(name))
			throw new ParseException("Unrecognized identifier: " + name);
		if (p.getNumArgsToFunction(name) != children.length)
			throw new ParseException(
					"Incorrect number of arguments passed to function: " + name);
		for (int i = 0; i < children.length; i++)
			children[i].checkIdentifiers(p);
	}

}
